from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)

bl_info = {
    "name" : "Rock Cliff Maker Add-On",
    "author" : "Maroc Sofiane", 
    "description" : "rock cliff maker is a powerful add-on that makes you able to create cliffs and edit them easily",
    "blender" : (4, 0, 0),
    "version" : (2, 0, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None


def sna_update_sna_rock_cliff_8A609(self, context):
    sna_updated_prop = self.sna_rock_cliff
    before_data = list(bpy.data.objects)
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'rock cliff update v2.blend') + r'\Object', filename=sna_updated_prop, link=False)
    new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
    appended_B941D = None if not new_data else new_data[0]
    for i_95C67 in range(len(bpy.context.view_layer.objects.selected)):
        if bpy.context.view_layer.objects.selected[i_95C67].select_get():
            bpy.context.view_layer.objects.active = bpy.context.view_layer.objects.selected[i_95C67]


_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


class SNA_PT_ROCK_CLIFF_MAKER__0C0AD(bpy.types.Panel):
    bl_label = 'rock cliff maker '
    bl_idname = 'SNA_PT_ROCK_CLIFF_MAKER__0C0AD'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'RC'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout.template_icon_view(bpy.context.scene, 'sna_rock_cliff', show_labels=False, scale=5.0, scale_popup=5.0)
        col_21DBA = layout.column(heading='Modifier', align=False)
        col_21DBA.alert = False
        col_21DBA.enabled = True
        col_21DBA.use_property_split = False
        col_21DBA.use_property_decorate = False
        col_21DBA.scale_x = 1.0
        col_21DBA.scale_y = 1.0
        col_21DBA.alignment = 'Expand'.upper()
        layout.prop(bpy.context.view_layer.objects.active.modifiers['Displace'], 'strength', text='', icon_value=0, emboss=True)
        layout.prop(bpy.context.view_layer.objects.active.modifiers['Displace'], 'mid_level', text='', icon_value=0, emboss=True)
        layout.prop(bpy.context.view_layer.objects.active.modifiers['Displace.001'], 'strength', text='', icon_value=0, emboss=True)
        layout.prop(bpy.context.view_layer.objects.active.modifiers['Displace.001'], 'mid_level', text='', icon_value=0, emboss=True)
        col_C0B58 = layout.column(heading='Shader', align=False)
        col_C0B58.alert = False
        col_C0B58.enabled = True
        col_C0B58.use_property_split = False
        col_C0B58.use_property_decorate = False
        col_C0B58.scale_x = 1.0
        col_C0B58.scale_y = 1.0
        col_C0B58.alignment = 'Expand'.upper()
        layout.prop(bpy.context.view_layer.objects.active.active_material.node_tree.nodes['Mix'].inputs[1], 'default_value', text='Color1', icon_value=0, emboss=True)
        layout.prop(bpy.context.view_layer.objects.active.active_material.node_tree.nodes['Mix'].inputs[2], 'default_value', text='Color2', icon_value=0, emboss=True)


def sna_rock_cliff_enum_items(self, context):
    enum_items = [['Mball', 'Mball', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'newi.png'))], ['cliff2', 'cliff2', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff2.png'))], ['cliff3', 'cliff3', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff3.png'))], ['cliff4', 'cliff4', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff4.png'))], ['cliff5', 'cliff5', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff5.png'))], ['cliff6', 'cliff6', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff6.png'))], ['cliff7', 'cliff7', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff7.png'))], ['cliff8', 'cliff8', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff8.png'))], ['cliff9', 'cliff9', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff9.png'))], ['cliff10', 'cliff10', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff10.png'))], ['cliff11', 'cliff11', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff11.png'))], ['cliff12', 'cliff12', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff12.png'))], ['cliff13', 'cliff13', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff13.png'))], ['cliff14', 'cliff14', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff14.png'))], ['cliff15', 'cliff15', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff15.png'))], ['cliff16', 'cliff16', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff16.png'))], ['cliff17', 'cliff17', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff17.png'))], ['cliff18', 'cliff18', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff18.png'))], ['cliff19', 'cliff19', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff19.png'))], ['cliff20', 'cliff20', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff20.png'))], ['cliff21', 'cliff21', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff21.png'))], ['cliff22', 'cliff22', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff22.png'))], ['cliff23', 'cliff23', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff23.png'))], ['cliff24', 'cliff24', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff24.png'))], ['cliff25', 'cliff25', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff25.png'))], ['cliff1', 'cliff1', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'cliff1.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_rock_cliff = bpy.props.EnumProperty(name='rock cliff', description='', items=sna_rock_cliff_enum_items, update=sna_update_sna_rock_cliff_8A609)
    bpy.utils.register_class(SNA_PT_ROCK_CLIFF_MAKER__0C0AD)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_rock_cliff
    bpy.utils.unregister_class(SNA_PT_ROCK_CLIFF_MAKER__0C0AD)
